#ifndef Q_ARRAY_LSL
#define Q_ARRAY_LSL

#define qArray list


integer qArrayIndex(list sizes, list coordinates)
{
  integer index;

  integer dimension = llGetListLength(sizes);
  integer i;
  for (i = 0; i < dimension; i++)
    {
      index *= llList2Integer(sizes, i);
      index += llList2Integer(coordinates, i);
    }

  // skip array header info:
  index += 1 + dimension;

  return index;
}



qArray qArrayCreate(list sizes)
{
  list array;

  integer dimension = llGetListLength(sizes);

  array = [ dimension ];
  array += sizes;

  integer start = qArrayIndex(sizes, []);
  integer end = qArrayIndex(sizes, sizes);

  integer i;
  for (i = start; i < end; i++)
    array += [ "" ];

  return array;
}


integer qArrayGetInteger(qArray array, list coordinates)
{
  integer dimension = llList2Integer(array, 0);

  list sizes = llList2List(array, 1, dimension);

  integer index = qArrayIndex(sizes, coordinates);

  return llList2Integer(array, index);
}



qArray qArraySetInteger(qArray array, list coordinates, integer value)
{
  integer dimension = llList2Integer(array, 0);

  list sizes = llList2List(array, 1, dimension);

  integer index = qArrayIndex(sizes, coordinates);

  return (llList2List(array, 0, index - 1) + 
	  [value] + 
	  llList2List(array, index + 1, -1));
}


#endif
